package common

import (
	"context"
	"os/exec"
	"strings"
	"time"

	_log "github.com/open-io/oio-exporter/common/log"
)

var log = _log.Default

func Index(data []string, key string) int {
	for i, v := range data {
		if key == v {
			return i
		}
	}
	return -1
}

func Exec(ctx context.Context, timeout time.Duration, command string) ([]byte, error) {
	return ExecString(ctx, timeout, command)
}

func ExecString(ctx context.Context, timeout time.Duration, command string) ([]byte, error) {

	cmds := strings.Split(command, " ")
	return ExecArray(ctx, timeout, cmds[0], cmds[1:]...)
}

func ExecArray(ctx context.Context, timeout time.Duration, name string, arg ...string) ([]byte, error) {
	cmdCtx, cancel := context.WithTimeout(ctx, timeout)
	defer cancel()

	return exec.CommandContext(cmdCtx, name, arg...).CombinedOutput()
}
